'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _mobxReact = require('mobx-react');

var _ExpandableSection = require('./ExpandableSection');

var _ExpandableSection2 = _interopRequireDefault(_ExpandableSection);

var _Checkbox = require('@material-ui/core/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _FormGroup = require('@material-ui/core/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Box = require('./Box');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UI for filtering an instance of SearchResultModelBase.  This component can be used on its own, or you can use
 * FilterButton to automatically display this component in a drawer that slides up from the bottom of the viewport.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      height: '100%',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch'
    },
    facetGroups: {
      overflow: 'auto',
      overflowX: 'hidden',
      flex: '1'
    },
    matches: {
      marginLeft: '5px',
      display: 'inline'
    },
    footer: {
      backgroundColor: theme.palette.secondary.main,
      padding: '12px 20px',
      color: 'white',
      justifyContent: 'space-between',
      alignItems: 'center'
    },
    itemsFound: {
      color: theme.palette.secondary.contrastText
    },
    title: (0, _extends4.default)({}, theme.typography.subtitle1, {
      marginBottom: '12px'
    }),
    noMargins: {
      margin: 0
    },
    groupLabel: {
      display: 'flex',
      alignItems: 'center'
    }
  };
};

var Filter = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFFilter' }), _dec2 = (0, _mobxReact.inject)('router'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Filter, _Component);

  function Filter(props) {
    (0, _classCallCheck3.default)(this, Filter);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Filter.__proto__ || Object.getPrototypeOf(Filter)).call(this, props));

    _this.onToggleFilter = function (facet) {
      _this.props.model.toggleFilter(facet);

      if (_this.props.refreshOnChange) {
        _this.refresh();
      }
    };

    _this.onViewResultsClick = function (e) {
      _this.props.onViewResultsClick(e);

      if (!e.isDefaultPrevented()) {
        _this.refresh();
      }
    };

    _this.createExpandAllState = function () {
      var state = {};
      var model = _this.props.model;


      if (model) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = model.facetGroups[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var group = _step.value;

            state[group.name] = true;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }

      return state;
    };

    _this.state = {
      expanded: props.expandAll ? _this.createExpandAllState() : {}
    };
    return _this;
  }

  (0, _createClass3.default)(Filter, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          model = _props.model,
          classes = _props.classes,
          title = _props.title;


      return _react2.default.createElement(
        'div',
        { className: classes.root },
        title ? _react2.default.createElement(
          'div',
          { className: classes.title },
          title
        ) : null,
        _react2.default.createElement(
          'div',
          { className: classes.facetGroups },
          (0, _get2.default)(model, 'facetGroups', []).map(function (facetGroup, i) {
            return _this2.renderFacetGroup(facetGroup, i);
          })
        ),
        model.filtersChanged && _react2.default.createElement(
          _Box.Hbox,
          { className: classes.footer, split: true },
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'subtitle1', className: classes.itemsFound },
            model.filters.length || 'No',
            ' filter',
            model.filters.length === 1 ? '' : 's',
            ' selected'
          ),
          _react2.default.createElement(
            _Button2.default,
            { variant: 'contained', size: 'large', color: 'default', onClick: this.onViewResultsClick },
            'View Results'
          )
        )
      );
    }
  }, {
    key: 'renderFacetGroup',
    value: function renderFacetGroup(group, key) {
      var _this3 = this;

      var _props2 = this.props,
          model = _props2.model,
          classes = _props2.classes,
          margins = _props2.margins;
      var expanded = this.state.expanded;

      var selection = [];

      var formGroup = _react2.default.createElement(
        _FormGroup2.default,
        { key: key },
        group.facets.map(function (facet, i) {
          var checked = false;

          if ((0, _get2.default)(model, 'filters', []).indexOf(facet.code) !== -1) {
            selection.push(facet);
            checked = true;
          }

          return _react2.default.createElement(_FormControlLabel2.default, {
            key: i,
            label: _react2.default.createElement(
              'div',
              { className: classes.groupLabel },
              _react2.default.createElement(
                'span',
                null,
                facet.name
              ),
              _react2.default.createElement(
                _Typography2.default,
                { variant: 'caption', className: classes.matches, component: 'span' },
                '(',
                facet.matches,
                ')'
              )
            ),
            control: _react2.default.createElement(_Checkbox2.default, {
              checked: checked,
              color: 'primary',
              onChange: _this3.onToggleFilter.bind(_this3, facet)
            })
          });
        })
      );

      var caption = null;

      if (selection.length === 1) {
        caption = selection[0].name;
      } else if (selection.length > 0) {
        caption = selection.length + ' selected';
      }

      return _react2.default.createElement(
        _ExpandableSection2.default,
        {
          key: key,
          title: group.name,
          caption: caption,
          expanded: expanded[group.name],
          onChange: function onChange(e, expanded) {
            return _this3.setState({ expanded: (0, _extends4.default)({}, _this3.state.expanded, (0, _defineProperty3.default)({}, group.name, expanded)) });
          },
          margins: margins
        },
        formGroup
      );
    }
  }, {
    key: 'refresh',
    value: function refresh() {
      var _props3 = this.props,
          router = _props3.router,
          model = _props3.model;

      router.applySearch((0, _defineProperty3.default)({}, this.props.queryParam, model.filters.toJSON()));
      model.refresh();
    }
  }]);
  return Filter;
}(_react.Component), _class2.propTypes = {
  /**
   * An instance of `SearchResultModelBase`
   */
  model: _propTypes2.default.object,

  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * A function to call when the user clicks the button to view updated results.  The default behavior can be
   * canceled by calling `preventDefault` on the passed in event.  The event is passed as the only argument.
   */
  onViewResultsClick: _propTypes2.default.func,

  /**
   * The query string parameter that should be updated when filters are changed.  The value will be an array
   * of codes for each selected facet.  Defaults to "filters"
   */
  queryParam: _propTypes2.default.string,

  /**
   * An optional title to display at the top of the component.
   */
  title: _propTypes2.default.string,

  /**
   * Set to false to remove the default left and right margins. Defaults to `true`.
   */
  margins: _propTypes2.default.bool,

  /**
   * Set to `true` to expand all groups on initial render
   */
  expandAll: _propTypes2.default.bool
}, _class2.defaultProps = {
  onViewResultsClick: Function.prototype,
  queryParam: 'filters',
  margins: true
}, _temp)) || _class) || _class) || _class);
exports.default = Filter;
//# sourceMappingURL=Filter.js.map