'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabsModel = exports.default = exports.styles = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxStateTree = require('mobx-state-tree');

var _Menu = require('./Menu');

var _TabsRow = require('./TabsRow');

var _TabsRow2 = _interopRequireDefault(_TabsRow);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _NavTab = require('./NavTab');

var _NavTab2 = _interopRequireDefault(_NavTab);

var _url = require('./utils/url');

var _core = require('@material-ui/core');

var _state2 = require('./utils/state');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Scrollable navigation tabs for the top of the app. All extra props are spread to the 
 * underlying Material UI Tabs element.  When a tab is clicked, the "top_nav_clicked" analytics
 * event is fired.
 */
var styles = exports.styles = function styles(theme) {
  return {
    tabs: {
      maxWidth: theme.maxWidth,
      flex: 1
    },
    root: {
      zIndex: theme.zIndex.appBar - 1,
      display: 'flex',
      justifyContent: 'center',
      position: 'relative',
      borderRadius: 0,
      '&::before': {
        content: "''",
        top: 0,
        left: 0,
        width: '15px',
        height: 'calc(100% - 3px)',
        position: 'absolute',
        background: 'linear-gradient(to right, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)',
        zIndex: 1
      },
      '&::after': {
        content: "''",
        top: 0,
        right: 0,
        width: '15px',
        height: 'calc(100% - 3px)',
        position: 'absolute',
        background: 'linear-gradient(to left, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)',
        zIndex: 1
      }
    },
    menu: {
      zIndex: theme.zIndex.appBar
    },
    menuPaper: {
      borderRadius: '0',
      position: 'relative',
      top: '1px'
    }
  };
};

var NavTabs = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFNavTabs' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      history = _ref.history;
  return { tabs: app.tabs, history: history };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(NavTabs, _Component);

  function NavTabs() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, NavTabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = NavTabs.__proto__ || Object.getPrototypeOf(NavTabs)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      open: false,
      menu: null,
      anchorEl: null,
      overTab: false,
      overMenu: false
    }, _this.renderTab = function (item, i) {
      return _react2.default.createElement(_NavTab2.default, (0, _extends3.default)({}, item, {
        key: i,
        item: item,
        onMouseEnter: _this.showMenu,
        onMouseLeave: _this.onTabLeave,
        onItemClick: _this.onItemClick,
        onClick: _this.onItemClick
      }));
    }, _this.showMenu = function (_ref3) {
      var menu = _ref3.menu,
          target = _ref3.target;

      _this.setState({
        overTab: true,
        anchorEl: target,
        menu: menu
      });
    }, _this.onMenuEnter = function () {
      _this.setState({ overMenu: true });
    }, _this.onMenuLeave = function () {
      _this.setState({ overMenu: false });
    }, _this.onTabLeave = function () {
      _this.setState({ overTab: false });
    }, _this.onItemClick = function () {
      _this.setState({ overTab: false, overMenu: false });
    }, _this.handleChange = function (_event, newValue) {
      var _this$props = _this.props,
          tabs = _this$props.tabs,
          history = _this$props.history;

      var item = tabs.items[newValue];
      var url = (0, _url.relativeURL)(item.url);

      if (history) {
        history.push(url, (0, _state2.parseState)(item.state));
      } else {
        window.location.href = url;
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(NavTabs, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          tabs = _props.tabs,
          classes = _props.classes,
          staticContext = _props.staticContext,
          history = _props.history,
          elevation = _props.elevation,
          tabsProps = (0, _objectWithoutProperties3.default)(_props, ['tabs', 'classes', 'staticContext', 'history', 'elevation']);
      var _state = this.state,
          menu = _state.menu,
          overTab = _state.overTab,
          overMenu = _state.overMenu,
          anchorEl = _state.anchorEl;

      var open = overTab || overMenu;

      if (!tabs) return null;

      var selected = tabs.selected;


      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          _core.Paper,
          { className: classes.root, elevation: elevation },
          _react2.default.createElement(_TabsRow2.default, (0, _extends3.default)({
            initialSelectedIdx: selected,
            onTabChange: this.handleChange,
            items: tabs.items,
            tabRenderer: this.renderTab,
            centered: true,
            classes: {
              root: classes.tabs,
              tab: classes.tab
            }
          }, tabsProps))
        ),
        !menu ? null : _react2.default.createElement(
          _core.Hidden,
          { xsDown: true },
          _react2.default.createElement(
            _core.Popper,
            {
              className: classes.menu,
              open: open,
              anchorEl: anchorEl,
              transition: true
            },
            function (_ref4) {
              var TransitionProps = _ref4.TransitionProps;
              return _react2.default.createElement(
                _core.Fade,
                (0, _extends3.default)({}, TransitionProps, { timeout: 350 }),
                _react2.default.createElement(
                  _core.Paper,
                  {
                    onMouseEnter: _this2.onMenuEnter,
                    onMouseLeave: _this2.onMenuLeave,
                    className: classes.menuPaper
                  },
                  menu
                )
              );
            }
          )
        )
      );
    }
  }]);
  return NavTabs;
}(_react.Component), _class2.propTypes = {
  classes: _propTypes2.default.objectOf(_propTypes2.default.string),

  /**
   * Controls the amount of drop shadow.
   */
  elevation: _propTypes2.default.number
}, _class2.defaultProps = {
  elevation: 2
}, _temp2)) || _class) || _class) || _class);
exports.default = NavTabs;
var TabsModel = exports.TabsModel = _mobxStateTree.types.model("TabsModel", {
  items: _mobxStateTree.types.array(_Menu.MenuItemModel)
}).views(function (self) {
  return {
    get selected() {
      var _getParent = (0, _mobxStateTree.getParent)(self),
          location = _getParent.location;

      var url = location.pathname + location.search;
      var index = self.items.findIndex(function (item) {
        return item.url === url;
      });
      return index === -1 ? null : index;
    }
  };
});
//# sourceMappingURL=NavTabs.js.map