'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class; /**
                          * @license
                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _reactHelmet = require('react-helmet');

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _CssBaseline = require('@material-ui/core/CssBaseline');

var _CssBaseline2 = _interopRequireDefault(_CssBaseline);

var _url = require('./utils/url');

var _delegate = require('delegate');

var _delegate2 = _interopRequireDefault(_delegate);

var _serviceWorker = require('./router/serviceWorker');

var _browser = require('./utils/browser');

var _mstMiddlewares = require('mst-middlewares');

var _mobxStateTree = require('mobx-state-tree');

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @private
 * Internal PWA root used when launching the app.  Do not use this class directly
 */
var styles = exports.styles = function styles(theme) {
  return {
    '@global': {
      'body.moov-modal': {
        overflow: 'hidden',
        position: 'fixed',
        maxWidth: '100vw',
        maxHeight: '100vh'
      },
      'body.moov-blur #root': {
        filter: 'blur(5px)',
        transition: 'filter ' + theme.transitions.duration.enteringScreen + 'ms'
      }
    }
  };
};

var PWA = (_dec = (0, _withStyles2.default)(styles), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      history = _ref.history,
      router = _ref.router;
  return { menu: app.menu, app: app, history: history, router: router, amp: app.amp };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3.default)(PWA, _Component);

  function PWA() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PWA);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = PWA.__proto__ || Object.getPrototypeOf(PWA)).call.apply(_ref2, [this].concat(args))), _this), _this._nextId = 0, _this.nextId = function () {
      return _this._nextId++;
    }, _this.resetPage = function () {
      window.scrollTo(0, 0);
      _this.props.menu.close();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(PWA, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          amp = _props.amp,
          app = _props.app;


      return _react2.default.createElement(
        _mobxReact.Provider,
        { nextId: this.nextId },
        _react2.default.createElement(
          _react.Fragment,
          null,
          _react2.default.createElement(_CssBaseline2.default, null),
          _react2.default.createElement(
            _reactHelmet.Helmet,
            null,
            _react2.default.createElement('html', { lang: 'en' }),
            _react2.default.createElement('meta', { charset: 'utf-8' }),
            _react2.default.createElement('meta', { name: 'viewport', content: 'width=device-width,initial-scale=1,minimum-scale=1,shrink-to-fit=no' }),
            _react2.default.createElement('meta', { name: 'theme-color', content: '#000000' }),
            app.description ? _react2.default.createElement('meta', { name: 'description', content: app.description }) : null,
            app.canonicalURL ? _react2.default.createElement('link', { rel: 'canonical', href: app.canonicalURL }) : null,
            _react2.default.createElement('link', { rel: 'manifest', href: '/manifest.json' }),
            _react2.default.createElement(
              'title',
              null,
              app.title
            )
          ),
          amp && _react2.default.createElement(
            _reactHelmet.Helmet,
            null,
            _react2.default.createElement('script', { async: true, src: 'https://cdn.ampproject.org/v0.js' }),
            _react2.default.createElement('script', { async: true, 'custom-element': 'amp-install-serviceworker', src: 'https://cdn.ampproject.org/v0/amp-install-serviceworker-0.1.js' })
          ),
          amp && _react2.default.createElement('amp-install-serviceworker', {
            src: 'https://' + app.location.hostname + '/service-worker.js',
            'data-iframe-src': 'https://' + app.location.hostname + '/pwa/install-service-worker.html',
            layout: 'nodisplay' }),
          this.props.children
        )
      );
    }
  }, {
    key: 'componentDidCatch',
    value: function componentDidCatch(error, info) {
      var app = this.props.app;


      app.applyState({
        page: 'Error',
        error: error.message,
        stack: info.componentStack
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props2 = this.props,
          router = _props2.router,
          app = _props2.app,
          history = _props2.history;


      if (router) {
        router.on('fetch', this.resetPage);
        router.watch(history, app.applyState);
      }

      this.bindAppStateToHistory();

      // scroll to the top and close the when the router runs a PWA route
      this.watchLinkClicks();

      // put os class on body for platform-specific styling
      this.addDeviceClassesToBody();

      // cache the launch screen for when the pwa is installed on the desktop
      (0, _serviceWorker.cache)('/?source=pwa');

      this.handleRejections();

      if (process.env.NODE_ENV !== 'production' && process.env.NODE_ENV !== 'test') {
        (0, _mstMiddlewares.connectReduxDevtools)(require("remotedev"), app);
      }
    }

    /**
     * Each time the app state changes, record the current app state as the history.state.
     * This makes restoring the page when going back really fast.
     */

  }, {
    key: 'bindAppStateToHistory',
    value: function bindAppStateToHistory() {
      var _props3 = this.props,
          app = _props3.app,
          history = _props3.history;


      var recordState = function recordState(snapshot) {
        var _history$location = history.location,
            pathname = _history$location.pathname,
            search = _history$location.search;

        history.replace(pathname + search, snapshot);
      };

      // record app state in history.state restore it when going back or forward
      // see Router#onLocationChange
      (0, _mobxStateTree.onSnapshot)(app, (0, _debounce2.default)(function (snapshot) {
        return !snapshot.loading && recordState(snapshot);
      }, 150));

      // record the initial state so that if the user comes back to the initial landing page the app state will be restored correctly.
      recordState(app.toJSON());
    }

    /**
     * When an unhandled rejection occurs, store the error in app state so it 
     * can be displayed to the developer.
     */

  }, {
    key: 'handleRejections',
    value: function handleRejections() {
      var _this2 = this;

      window.addEventListener('unhandledrejection', function (event) {
        return _this2.props.app.onError(event.reason);
      });
    }

    /**
     * Adds a css class corresponding to the browser to the body element
     * @private
     */

  }, {
    key: 'addDeviceClassesToBody',
    value: function addDeviceClassesToBody() {
      if ((0, _browser.isSafari)()) {
        document.body.classList.add('moov-safari');
      }
    }

    /**
     * Returns true if client-side navigation should be forced, otherwise false
     * @param {HTMLElement} linkEl
     * @return {Boolean} 
     */

  }, {
    key: 'shouldNavigateOnClient',
    value: function shouldNavigateOnClient(linkEl) {
      var href = linkEl.getAttribute('href');
      var linkTarget = linkEl.getAttribute('target');

      // false if the element is not a link
      if (linkEl.tagName.toLowerCase() !== 'a') return false;

      // false if the link was rendered by react-storefront/Link - it will handle nav on its own
      if (linkEl.getAttribute('data-moov-link') === 'on') return false;

      // false if link has data-reload="on|true"
      if (['true', 'on'].indexOf(linkEl.getAttribute('data-reload')) !== -1) return false;

      // false for links with a target other than self
      if (linkTarget && linkTarget !== '_self') return false;

      return (0, _url.canUseClientSideNavigation)(href, this.props.router);
    }

    /**
     * Watches for clicks on all links and forces client-side navigation if the domain is the same.
     * This behavior can be overridden by adding data-reload="on" to any link
     */

  }, {
    key: 'watchLinkClicks',
    value: function watchLinkClicks() {
      var _this3 = this;

      // capture click events
      (0, _delegate2.default)('a', 'click', function (e) {
        var delegateTarget = e.delegateTarget;


        if (_this3.shouldNavigateOnClient(delegateTarget)) {
          // don't reload the page
          e.preventDefault();

          // instead do the navigation client-side using the history API
          _this3.props.history.push(delegateTarget.getAttribute('href'));
        }
      });
    }
  }]);
  return PWA;
}(_react.Component)) || _class) || _class) || _class);
exports.default = PWA;
//# sourceMappingURL=PWA.js.map