'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _mobxReact = require('mobx-react');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Hidden = require('@material-ui/core/Hidden');

var _Hidden2 = _interopRequireDefault(_Hidden);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UI for sorting an instance of SearchResultModelBase.  This component can be used on its own, or you can use
 * SortButton to automatically display this component in a drawer that slides up from the bottom of the viewport.
 */
var styles = exports.styles = function styles(theme) {
  return {
    container: {
      padding: '15px 0 0 15px'
    },
    option: {
      boxShadow: 'none',
      width: 'calc(50% - 15px)',
      margin: '0 15px 15px 0'
    }
  };
};

var Sort = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFSort' }), _dec2 = (0, _mobxReact.inject)('router'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Sort, _Component);

  function Sort() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Sort);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Sort.__proto__ || Object.getPrototypeOf(Sort)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function (option, e) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          model = _this$props.model,
          queryParam = _this$props.queryParam,
          router = _this$props.router;

      onSelect(option, e);

      if (!e.isDefaultPrevented()) {
        router.applySearch((0, _defineProperty3.default)({}, queryParam, option.code));
        model.setSort(option);
        model.refresh();
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Sort, [{
    key: 'render',
    value: function render() {
      var variant = this.props.variant;


      _Hidden2.default;

      if (variant === 'buttons') {
        return this.renderButtons();
      } else if (variant === 'menu-items') {
        return this.renderMenu();
      } else {
        return null;
      }
    }
  }, {
    key: 'renderButtons',
    value: function renderButtons() {
      var _this2 = this;

      var _props = this.props,
          model = _props.model,
          classes = _props.classes;

      var options = model.sortOptions;

      return _react2.default.createElement(
        'div',
        { className: classes.container, onClick: this.handleSort },
        options && options.map(function (option, i) {
          return _react2.default.createElement(
            _Button2.default,
            {
              className: classes.option,
              color: model.sort === option.code ? 'primary' : 'default',
              variant: 'contained',
              onClick: _this2.onClick.bind(_this2, option),
              key: i
            },
            option.name
          );
        })
      );
    }
  }, {
    key: 'renderMenu',
    value: function renderMenu() {
      var _this3 = this;

      var model = this.props.model;

      var options = model.sortOptions;

      return _react2.default.createElement(
        _react.Fragment,
        null,
        options && options.map(function (option, i) {
          return _react2.default.createElement(
            _MenuItem2.default,
            { key: i, onClick: _this3.onClick.bind(_this3, option) },
            option.name
          );
        })
      );
    }
  }]);
  return Sort;
}(_react.Component), _class2.propTypes = {
  /**
   * A function to call when a sort option is selected.  The option and event are passed.
   * The default behavior can be prevented by called `preventDefault()` on the passed in event.
   */
  onSelect: _propTypes2.default.func,

  /**
   * A instance of SearchResultsModelBase
   */
  model: _propTypes2.default.object,

  /**
   * The query string parameter that should be updated when the sort is changed.  The value will the
   * code corresponding to the selected sortOption.  Defaults to "sort".
   */
  queryParam: _propTypes2.default.string,

  /**
   * Controls how sort options are displayed.  Can be "menu-items" or "buttons".  Defaults to "buttons"
   */
  variant: _propTypes2.default.oneOf(['menu-items', 'buttons'])
}, _class2.defaultProps = {
  onSelect: Function.prototype,
  queryParam: 'sort',
  variant: 'buttons'
}, _temp2)) || _class) || _class) || _class);
exports.default = Sort;
//# sourceMappingURL=Sort.js.map