'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHelmet = require('react-helmet');

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      zIndex: theme.zIndex.amp.modal + 2, // zIndex of AppBar's withAmp + 1
      backgroundColor: 'rgba(255, 255, 255, .8)'
    }
  };
};

/**
 * An AMP-compatible modal based on `<amp-lightbox>`
 * 
 * All props not specifically documented here are spread to the `<amp-lightbox>` element.
 * More info about amp-lightbox on AMP docs: https://www.ampproject.org/docs/reference/components/amp-lightbox
 * 
 * Usage example:
 * 
 *  <button on="tap:modal">Open Modal</button>
 * 
 *  <AmpModal id="modal">
 *    <button on="tap:modal.close">Close Modal</button>
 *    <div>Modal content ...</div>
 *  </AmpModal>
 */
var AmpModal = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFAmpModal' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AmpModal, _Component);

  function AmpModal() {
    (0, _classCallCheck3.default)(this, AmpModal);
    return (0, _possibleConstructorReturn3.default)(this, (AmpModal.__proto__ || Object.getPrototypeOf(AmpModal)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmpModal, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          id = _props.id,
          animateIn = _props.animateIn,
          classes = _props.classes,
          children = _props.children,
          others = (0, _objectWithoutProperties3.default)(_props, ['id', 'animateIn', 'classes', 'children']);


      if (!id) {
        return new Error('Prop `id` is required for `AmpModal` component');
      }

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          _reactHelmet.Helmet,
          { key: 'helmet' },
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-lightbox', src: 'https://cdn.ampproject.org/v0/amp-lightbox-0.1.js' })
        ),
        _react2.default.createElement(
          'amp-lightbox',
          (0, _extends3.default)({
            key: 'lightbox',
            layout: 'nodisplay',
            id: id,
            'animate-in': animateIn,
            'class': classes.root
          }, others),
          children
        )
      );
    }
  }]);
  return AmpModal;
}(_react.Component), _class2.propTypes = {
  /**
   * The id for the amp-lightbox element.
   * This is REQUIRED attribute.
   */
  id: _propTypes2.default.string,

  /**
   * Defines the style of animation for opening the lightbox. 
   * By default, this will be set to `fade-in`. 
   * Valid values are `fade-in`, `fly-in-bottom` and `fly-in-top`.
   * 
   * Note: The `fly-in-*` animation presets modify the transform property of the amp-lightbox element. 
   * Do not rely on transforming the amp-lightbox element directly. 
   * If you need to apply a transform, set it on a nested element instead. 
   */
  animateIn: _propTypes2.default.string
}, _class2.defaultProps = {
  animateIn: 'fade-in'
}, _temp)) || _class);
exports.default = AmpModal;
//# sourceMappingURL=AmpModal.js.map