'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = launchClient;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _renderers = require('./renderers');

var _createBrowserHistory = require('history/createBrowserHistory');

var _createBrowserHistory2 = _interopRequireDefault(_createBrowserHistory);

var _registerServiceWorker = require('./registerServiceWorker');

var _registerServiceWorker2 = _interopRequireDefault(_registerServiceWorker);

var _PWA = require('./PWA');

var _PWA2 = _interopRequireDefault(_PWA);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Bootstraps the PWA react application.
 * @param {options} options
 * @param {React.Element} options.app The root app element
 * @param {Object} options.theme A material-ui theme
 * @param {Object} options.model A mobx-state-tree model class
 * @param {HTMLElement} options.target The DOM element to mount onto
 */
function launchClient(_ref) {
  var App = _ref.App,
      theme = _ref.theme,
      model = _ref.model,
      router = _ref.router,
      _ref$target = _ref.target,
      target = _ref$target === undefined ? document.getElementById('root') : _ref$target;

  var history = (0, _createBrowserHistory2.default)();

  (0, _renderers.hydrate)({
    component: _react2.default.createElement(
      _PWA2.default,
      null,
      _react2.default.createElement(App, null)
    ),
    model: model,
    theme: theme,
    target: target,
    providerProps: {
      history: history,
      router: router
    }
  });

  (0, _registerServiceWorker2.default)();
} /**
   * @license
   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
   */
//# sourceMappingURL=launchClient.js.map